import java.util.Scanner;

public abstract class WildCard extends Card {

    String nextColor;
    Scanner scanner = new Scanner(System.in);
    public WildCard(int score) {
        super(score);
    }

    public void chooseColor() {
        int num = 0;
        while (num < 1 && num > 4) {
            System.out.println("plz choose a color (just choose the number)\n1:blue 2:red 3:yellow 4:green");
            num = scanner.nextInt();
        }
        switch (num) {
            case 1: {
                System.out.println("next:" + blue + "blue" + set);
                setNextColor("blue");
                return;
            }
            case 2: {
                System.out.println("next:" + red + "red" + set);
                setNextColor("red");
                return;
            }
            case 3: {
                System.out.println("next:" + yellow + "yellow" + set);
                setNextColor("yellow");
                return;
            }
            case 4: {
                System.out.println("next:" + green + "green" + set);
                setNextColor("green");
                return;
            }

        }
    }

    public void setNextColor(String nextColor) {
        this.nextColor = nextColor;
    }

    public String getNextColor() {
        return nextColor;
    }

    @Override
    public String toString() {
        String s = "|$$$$$$$$$$$$$$$|\n";
        s += "|               |\n";
        s += name;
        s += "|               |\n";
        s += "|$$$$$$$$$$$$$$$|\n";
        return s;
    }

    @Override
    public void print() {
        System.out.println(toString());
    }

    public boolean isAvailableToPutAWildCard(int numOfChosenCard, User chosenUser, Card upperCard) {//if there is another card to choose you can not choose wild card
        if (upperCard instanceof WildCard) // you can not put a wild card if upper card is wild
            return false;
        for (Card card : chosenUser.getUserCards()) {
            if (card.isAvailableToPut(numOfChosenCard, chosenUser, upperCard) && !card.equals(chosenUser.getUserCards().get(numOfChosenCard))) {
                return false;
            }
        }
        return false;
    }
}
